<% if @image_base %>
FROM <%= @image_base %>
# TODO: add checks for platform and platform_version if image_base is used
#       to make sure we use correct OS env to build packages
<% else %>
FROM <%= @platform %>:<%= @platform_version %>
<% end %>

MAINTAINER salamanka.serge@gmail.com

RUN apt-get -y update && \
    apt-get -y install wget git

# TODO: implement different procedures for chefdk installation depending on package
# RUN wget "http://packages.chef.io/files/stable/chefdk/<%= @chefdk_version %>/el/<%= @platform_version %>/chef-${VERSION}-1.el6.x86_64.rpm" -O /tmp/chef-client.rpm && \
#    rpm2cpio /tmp/chef-client.rpm | cpio -idmv && \
#    rm -rf /tmp/chef-client.rpm
# NOTE: use option --chef-license "accept" if later Chef versions are used
RUN wget "http://packages.chef.io/files/stable/chefdk/<%= @chefdk_version %>/<%= @platform %>/<%= @platform_version %>/chefdk_<%= @chefdk_version %>-1_amd64.<%= @package %>" -O /tmp/chefdk.<%= @package %> && \
    dpkg -i /tmp/chefdk.<%= @package %> && \
    rm -f /tmp/chefdk.<%= @package %> && \
    echo "source 'https://supermarket.chef.io'\n cookbook 'omnibus'\n cookbook 'chef-ingredient', git: 'https://github.com/chef-cookbooks/chef-ingredient.git', branch: 'main'" > Berksfile && \
    berks install && berks vendor cookbooks && \
    chef-client --chef-license accept -z -o "omnibus::default" && \
    rm -rf /root/.chef /root/.berkshelf

## Preinstall gems
WORKDIR /root
COPY files/Gemfile /root/Gemfile
COPY files/bundle.sh /root/bundle.sh
COPY --chown=omnibus:omnibus files/bash.sh /home/omnibus/bash.sh
COPY --chown=omnibus:omnibus files/build.sh /home/omnibus/build.sh
RUN chmod +x /root/bundle.sh && \
    chmod +x /home/omnibus/bash.sh && \
    chmod +x /home/omnibus/build.sh && \
    /root/bundle.sh

ENV HOME /home/omnibus

## ONBUILD to build project
# ONBUILD COPY --chown=omnibus:omnibus omnibus/ /home/omnibus/project/
#
# WORKDIR /home/omnibus/project
# ONBUILD RUN bash -c 'source /home/omnibus/load-omnibus-toolchain.sh ; bundle install --binstubs bin --without development test'
# ONBUILD RUN echo "Usage: docker run  -it -e OMNIBUS_PROJECT=${PROJECT_NAME} -v ${PWD}/pkg:/home/omnibus/project/pkg ${PROJECT_NAME}/builder/ubuntu/<%= @platform_version %>"

CMD ["/home/omnibus/build.sh", "PROJECT_NAME"]
